VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMakeGray 
   Caption         =   "MakeGray"
   ClientHeight    =   4215
   ClientLeft      =   1635
   ClientTop       =   1230
   ClientWidth     =   4950
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4215
   ScaleWidth      =   4950
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   1680
      Top             =   1920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picColor 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   1800
      Left            =   0
      ScaleHeight     =   116
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   125
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   1935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "&Save As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMakeGray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const BITSPIXEL = 12

Private Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Private Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long
' Convert a color image to gray scale.
Private Sub MakeGray(ByVal picColor As PictureBox)
Dim bm As BITMAP
Dim X As Integer
Dim Y As Integer
Dim r As Byte
Dim g As Byte
Dim b As Byte
Dim gray As Byte
Dim bytes() As Byte
Dim wid As Single
Dim hgt As Single

    ' Get the bitmap information.
    GetObject picColor.Image, Len(bm), bm
    wid = bm.bmWidth
    hgt = bm.bmHeight

    ' Make room for the byte data.
    ReDim bytes(0 To bm.bmWidthBytes - 1, 0 To hgt - 1)

    ' Get the data.
    GetBitmapBits picColor.Image, _
        bm.bmWidthBytes * bm.bmHeight, _
        bytes(0, 0)

    ' Convert the data to gray scale.
    For Y = 0 To hgt - 1
        For X = 0 To wid - 1
            ' Get the current pixel value.
            r = bytes(X * 3, Y)
            g = bytes(X * 3 + 1, Y)
            b = bytes(X * 3 + 2, Y)

            ' Set the new grayscale pixel value.
            gray = (CSng(r) + g + b) / 3
            bytes(X * 3, Y) = gray
            bytes(X * 3 + 1, Y) = gray
            bytes(X * 3 + 2, Y) = gray
        Next X
    Next Y

    ' Set the new pixel values.
    SetBitmapBits picColor.Image, _
        bm.bmWidthBytes * bm.bmHeight, bytes(0, 0)
    picColor.Picture = picColor.Image
End Sub

Private Sub Form_Load()
    picColor.AutoSize = True
    picColor.AutoRedraw = True

    ' See if the screen is using 24-bit color.
    If (GetDeviceCaps(hdc, BITSPIXEL) <> 24) Then
        MsgBox "Sorry, but the screen is not configured to use 24-bit color." & _
            vbCrLf & "For information on selecting 24-bit color, go to:" & _
            vbCrLf & vbCrLf & "http://www.vb-helper.com/highclr.htm"
        Unload Me
        Exit Sub
    End If
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuFileOpen_Click()
    On Error Resume Next
    dlgFile.CancelError = True
    dlgFile.Flags = _
        cdlOFNExplorer Or _
        cdlOFNFileMustExist Or _
        cdlOFNHideReadOnly Or _
        cdlOFNLongNames
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " selecting file." & vbCrLf & _
            Err.Description
        Exit Sub
    End If

    picColor.Picture = LoadPicture(dlgFile.FileName)
    If Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " opening picture file." & vbCrLf & _
            Err.Description
        Exit Sub
    End If

    ' Make the form fit.
    Width = Width - ScaleWidth + picColor.Width
    Height = Height - ScaleHeight + picColor.Height
    picColor.Visible = True

    ' Convert to gray scale.
    Screen.MousePointer = vbHourglass
    DoEvents
    MakeGray picColor
    Screen.MousePointer = vbDefault
End Sub

Private Sub mnuFileSaveAs_Click()
    On Error Resume Next
    dlgFile.CancelError = True
    dlgFile.Flags = _
        cdlOFNExplorer Or _
        cdlOFNOverwritePrompt Or _
        cdlOFNHideReadOnly Or _
        cdlOFNLongNames
    dlgFile.ShowSave
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " selecting file." & vbCrLf & _
            Err.Description
        Exit Sub
    End If

    SavePicture picColor.Picture, dlgFile.FileName
    If Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " saving picture file." & vbCrLf & _
            Err.Description
        Exit Sub
    End If
End Sub
